using Nemerle.Utility;

namespace Oyster.Units
{
	/// Base class for all unit types
	abstract public class UnitTypeBase
	{
		/// Unit value as double
		[Accessor] _value : double;
		

		/// Constructs given unit type instance from any other unit type instance
		protected this(value : UnitTypeBase)
		{
			// Perform normalization-denormalization here
			this(value._value * value.NormalizationCoef / NormalizationCoef)
		}
		
		/// Constructs given unit type instance from double
		protected this(value : double)
		{
			_value = value
		}
		

		/// Unit type normalization coefficient
		abstract public NormalizationCoef : double { get; }
		
		/// ToString() override
		override public ToString() : string
		{
			_value.ToString()
		}
	}
}
